/**
 * 
 */
package net.smartlab.web.auth.handlers;

import java.util.Map;

import org.apache.commons.beanutils.BeanUtils;

import net.smartlab.web.BusinessException;
import net.smartlab.web.auth.User;
import net.smartlab.web.auth.User.Status;

/**
 * @author svetrini
 */
public class BusinessObjectAssociationRegistrationHandler extends AbstractAssociationRegistrationHandler {

	public static final String BUSINESS_OBJECT_ASSOCIATION_KEY = "BUSINESS_OBJECT_ASSOCIATION_KEY";


	/*
	 * (non-Javadoc)
	 * 
	 * @see net.smartlab.web.auth.handlers.AbstractAssociationRegistrationHandler#associate(java.util.Map,
	 *      net.smartlab.web.auth.User)
	 */
	protected User associate(Map parameters, User user) throws BusinessException {
		user.setProperty(BUSINESS_OBJECT_ASSOCIATION_KEY, (String)parameters.get(BUSINESS_OBJECT_ASSOCIATION_KEY));
		// update user infos in db
		domain.updateUser(user);
		return user;
	}

	/**
	 * @param parameters
	 * @param user
	 * @return
	 * @throws BusinessException
	 */
	protected User updateUser(Map parameters, User user) throws BusinessException {
		if (user == null || user.getId() == 0) {
			// insert new user in db
			user = new User();
			try {
				BeanUtils.populate(user, parameters);
			} catch (Exception e) {
				throw new BusinessException("Error inserting user", e);
			}
		}
		user.setStatus(Status.PENDING);
		// update user infos in db
		domain.updateUser(user);
		return user;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see net.smartlab.web.auth.Handler#destroy()
	 */
	public void destroy() throws Exception {
		// TODO Auto-generated method stub
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see net.smartlab.web.auth.Handler#init(java.util.Map)
	 */
	public void init(Map parameters) throws Exception {
		// TODO Auto-generated method stub
	}
}
