package net.smartlab.web.auth.handlers;

import java.awt.AlphaComposite;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.font.FontRenderContext;
import java.awt.font.GlyphVector;
import java.awt.geom.AffineTransform;
import java.awt.geom.Rectangle2D;
import java.awt.image.BufferedImage;
import java.io.ByteArrayOutputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.io.Serializable;
import java.net.URL;
import java.util.List;
import java.util.Map;

import javax.imageio.ImageIO;
import javax.servlet.GenericServlet;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.swing.ImageIcon;

import net.smartlab.web.auth.RegistrationHandler;
import net.smartlab.web.auth.User;

/**
 * TODO documentation
 * 
 * Required parameters are:
 * <ul>
 *   <li><code>font.name</code></li>
 *   <li><code>font.color</code></li>
 *   <li><code>font.size</code></li>
 *   <li><code>image.background</code></li>
 *   <li><code>image.format</code></li>
 *   <li><code>text.length</code></li>
 * </ul>
 * 
 * Optional parameters are:
 * <ul>
 *   <li><code>text.chars</code></li>
 * </ul>
 * 
 * @author rlogiacco
 */
public class CaptchaRegistrationHandler implements RegistrationHandler {

	/**
	 * TODO documentation
	 */
	private String id;

	/**
	 * TODO documentation
	 */
	private Font font;

	/**
	 * TODO documentation
	 */
	private Color color;

	/**
	 * TODO documentation
	 */
	private ImageIcon background;

	/**
	 * TODO documentation
	 */
	private String format;
	
	/**
	 * TODO documentation
	 */
	private final String chars = CHARS;

	/**
	 * TODO documentation
	 */
	private final static String CHARS = "ABCDEFGHIJKLMNOPQRSTUWXYZ1234567890";


	public static void main(String[] args) throws Exception {
		CaptchaRegistrationHandler i = new CaptchaRegistrationHandler();
		OutputStream os = new FileOutputStream(args[0]);
		i.font = new Font(args[1], Font.ITALIC, Integer.parseInt(args[2]));
		i.color = new Color(255, 0, 0, 128);
		i.setBackground(new URL(args[3]));
		byte[] buffer = i.generate("some simple text").getImage();
		os.write(buffer);
		os.close();
	}

	/**
	 * TODO documentation
	 * 
	 * @param font
	 */
	public void setFont(Font font) {
		this.font = font;
	}

	/**
	 * TODO documentation
	 * 
	 * @param Color
	 */
	public void setColor(Color color) {
		this.color = color;
	}

	/**
	 * TODO documentation
	 * 
	 * @param background
	 */
	public void setBackground(ImageIcon background) {
		this.background = background;
	}

	/**
	 * TODO documentation
	 * 
	 * @param background
	 */
	public void setBackground(URL background) {
		this.background = new ImageIcon(background);
	}

	/**
	 * TODO documentation
	 * 
	 * @param length
	 * @return
	 * @throws Exception
	 */
	public Captcha generate(int length) throws Exception {
		// generate a string
		StringBuffer randomized = new StringBuffer(length);
		for (int i = 0; i < length; i++) {
			int index = (int)Math.floor(Math.random() * chars.length());
			randomized.append(chars.charAt(index));
		}
		return this.generate(randomized.toString());
	}

	/**
	 * TODO documentation
	 * 
	 * @param text
	 * @return
	 * @throws Exception
	 */
	public Captcha generate(String text) throws Exception {
		int width = background.getIconWidth();
		int height = background.getIconHeight();
		BufferedImage buffer = new BufferedImage(width, height, BufferedImage.TYPE_INT_RGB);
		Graphics2D canvas = buffer.createGraphics();
		canvas = buffer.createGraphics();
		canvas.setComposite(AlphaComposite.Src);
		canvas.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
		canvas.drawImage(background.getImage(), null, null);
		canvas.setComposite(AlphaComposite.SrcOver);
		canvas.setFont(font);
		canvas.setColor(color);
		FontRenderContext renderer = canvas.getFontRenderContext();
		Rectangle2D bounds = font.getStringBounds(text, renderer);
		GlyphVector glyphs = font.createGlyphVector(renderer, text);
		for (int i = 0; i < glyphs.getNumGlyphs(); i++) {
			double rotation = (Math.random() * 1.25) - 0.5;
			AffineTransform transform = AffineTransform.getRotateInstance(rotation);
			// double scaling = (Math.random() - 0.5) * 0.5;
			// transform.scale(scaling, scaling);
			glyphs.setGlyphTransform(i, transform);
		}
		// canvas.drawGlyphVector(glyphs, 10, 10);
		canvas.drawGlyphVector(glyphs, font.getSize2D(), (float)(((float)height / 2) - bounds.getY()));
		Captcha captcha = new Captcha(text, buffer, format);
		return captcha;
	}

	/**
	 * @see net.smartlab.web.auth.RegistrationHandler#onRegister(java.util.Map,
	 *      java.lang.String)
	 */
	public String onRegister(Map props, String step) throws Exception {
		// TODO implementation
		return null;
	}

	/**
	 * @see net.smartlab.web.auth.RegistrationHandler#onUpdate(net.smartlab.web.auth.User,
	 *      java.util.Map, java.lang.String)
	 */
	public String onUpdate(User user, Map props, String step) throws Exception {
		// TODO implementation
		return null;
	}

	/**
	 * @see net.smartlab.web.auth.Handler#destroy()
	 */
	public void destroy() throws Exception {
		// TODO implementation
	}

	/**
	 * @see net.smartlab.web.auth.Handler#init(java.util.Map)
	 */
	public void init(Map parameters) throws Exception {
		this.setFont(new Font((String)parameters.get("font.name"), Font.PLAIN, Integer.parseInt((String)parameters
				.get("font.size"))));
		this.setColor(Color.decode((String)parameters.get("font.color")));
		this.format = (String)parameters.get("image.format");
		this.setBackground(new URL((String)parameters.get("image.background")));
	}

	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public List getStates() {
		// TODO Auto-generated method stub
		return null;
	}


	/**
	 * TODO documentation
	 * 
	 * @author rlogiacco
	 */
	public static class Captcha implements Serializable {

		private static final long serialVersionUID = -1207295416053937848L;

		private String text;

		private byte[] image;

		private String format;


		/**
		 * TODO documentation
		 *
		 * @param text
		 * @param image
		 * @param format
		 * @throws IOException
		 */
		private Captcha(String text, BufferedImage image, String format) throws IOException {
			ByteArrayOutputStream out = new ByteArrayOutputStream();
			ImageIO.write(image, format, out);
			this.image = out.toByteArray();
			this.format = format;
			this.text = text;
		}

		/**
		 * Read accessor method for the string property.
		 * 
		 * @return the string
		 */
		public String getText() {
			return text;
		}

		/**
		 * Read accessor method for the image property.
		 * 
		 * @return the image
		 */
		public byte[] getImage() {
			return image;
		}

		/**
		 * Read accessor method for the format property.
		 * 
		 * @return the format
		 */
		public String getFormat() {
			return format;
		}
	}

	/**
	 * TODO documentation
	 *
	 * @author rlogiacco
	 *
	 */
	public static class Servlet extends GenericServlet {

		private static final long serialVersionUID = -8007280319272420307L;

		/**
		 * @see javax.servlet.GenericServlet#service(javax.servlet.ServletRequest, javax.servlet.ServletResponse)
		 */
		public void service(ServletRequest request, ServletResponse response) throws ServletException, IOException {
			HttpSession session = ((HttpServletRequest)request).getSession();
			Captcha captcha = (Captcha)session.getAttribute("net.smartlab.web.auth.captcha");
			session.removeAttribute("net.smartlab.web.auth.captcha");
			response.setContentLength(captcha.image.length);
			response.setContentType("image/" + captcha.format);
			OutputStream out = response.getOutputStream();
			out.write(captcha.image);
			out.close();
		}
	}
}