/**
 * 
 */
package net.smartlab.web.auth.handlers;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import java.util.Map;

import net.smartlab.web.auth.AuthorizationHandler;
import net.smartlab.web.auth.Scope;
import net.smartlab.web.auth.User;

/**
 * @author svetrini
 */
public class ScopeMethodAuthorizationHandler implements AuthorizationHandler {

	/**
	 * Logger for this class
	 */
	private static final Log logger = LogFactory.getLog(ScopeMethodAuthorizationHandler.class);

	/**
	 * @uml.property name="id"
	 */
	private String id;


	/**
	 * @see net.smartlab.web.auth.AuthorizationHandler#onRequest(java.lang.Object[])
	 */
	public boolean onRequest(User user, Scope scope, Map parameters) {
		if (logger.isDebugEnabled()) {
			logger.debug("onRequest(" + user + ", " + scope + ", " + parameters + ") - start");
		}
		Scope other = (Scope)parameters.get(Scope.class);
		try {
			if (Class.forName(other.getType().getType()).isInstance(
					Class.forName(scope.getType().getType()).newInstance())) {
				return true;
			}
		} catch (Exception e) {
			logger.warn("onRequest(" + user + ", " + scope + ", " + parameters + ") - exception ignored", e);
			// NOP
		}
		return false;
	}

	/**
	 * @see net.smartlab.web.auth.Handler#destroy()
	 */
	public void destroy() throws Exception {
		// Do nothing
	}

	/**
	 * @see net.smartlab.web.auth.Handler#getId()
	 */
	/**
	 * @return
	 * @uml.property name="id"
	 */
	public String getId() {
		return this.id;
	}

	/**
	 * @see net.smartlab.web.auth.Handler#init(java.util.Map)
	 */
	public void init(Map parameters) throws Exception {
		if (logger.isDebugEnabled()) {
			logger.debug("init(" + parameters + ") - start");
		}
		this.id = (String)parameters.get("id");
	}

	/**
	 * @param id
	 * @uml.property name="id"
	 */
	public void setId(String id) {
		this.id = id;
	}
}