/**
 * 
 */
package net.smartlab.web.auth;

import java.util.Iterator;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import net.smartlab.web.ActionException;
import net.smartlab.web.BusinessException;
import net.smartlab.web.DynaAction;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionRedirect;
import org.apache.struts.action.DynaActionForm;

/**
 * @author svetrini
 */
public class RegisterAction extends DynaAction {

	public static final String STEP = "step";

	/**
	 * Buffered <code>Domain</code> instance.
	 * 
	 * @uml.property name="domain"
	 * @uml.associationEnd multiplicity="(1 1)"
	 */
	protected Domain domain = Domain.getInstance();


	public ActionForward user(ActionForm form, HttpServletRequest request, HttpServletResponse response,
			ActionMapping mapping) throws Exception {
		String result = null;
		DynaActionForm dform = (DynaActionForm)form;
		String step = dform.getString(STEP);
		if (step == null || "".equals(step))
			step = RegistrationHandler.STATE_START;
		try {
			result = domain.register(dform.getMap(), step);
		} catch (BusinessException e) {
			logger.error("exception at step: " + step, e);
			throw new ActionException(e.getMessage());
		}
		dform.set(STEP, result);
		ActionForward forward = mapping.findForward(result);
		if (forward == null) {
			forward = this.user(dform, request, response, mapping);
		}
		ActionRedirect redirect = new ActionRedirect(forward);
		String paramString = rewriteParams(dform.getMap(), redirect);
		logger.debug("new params string: " + paramString);
		return redirect;
	}

	public static String rewriteParams(Map props, ActionRedirect redirect) {
		if (props != null) {
			Iterator it = props.entrySet().iterator();
			while (it.hasNext()) {
				Map.Entry pairs = (Map.Entry)it.next();
				if (pairs.getKey() instanceof String && pairs.getValue() instanceof String) {
					String value = (String)pairs.getValue();
					String key = (String)pairs.getKey();
					if (value != null && key != null && !"".equals(value) && !"".equals(key))
					redirect.addParameter(key, value);
				}
			}
		}
		return redirect.getParameterString();
	}
}
